const fs = require("fs");
const jsdom = require("jsdom");
const { JSDOM } = jsdom;
const { window } = new JSDOM("");
global.window = window;
var showdown = require("showdown");
const converterShowdown = new showdown.Converter();
const xmlJs = require("xml-js");

const useShowdown = (HTML) => {
  return converterShowdown.makeMarkdown(HTML);
};

fs.readFile("./event-test.xml", "utf8", (err, data) => {
  if (err) {
    console.error(err);
    return;
  }
  parseXML(data);
});

const parseXML = (XML) => {
  const js = xmlJs.xml2js(XML);

  for (let i = 0; i < js.elements[0].elements.length; ++i) {
    const title = js.elements[0].elements[i].attributes.title;
    let short = useShowdown(
      xmlJs.js2xml(js.elements[0].elements[i].elements[0])
    );
    short = short.replace(/\n+$/, "");
    const dateStr = js.elements[0].elements[i].attributes.date;
    const timeStr = js.elements[0].elements[i].attributes.time;
    const date = new Date(`${dateStr} ${timeStr} EST`); // need to add EST
    const room = js.elements[0].elements[i].attributes.room;
    // const online
    // const location

    const abstract = useShowdown(
      xmlJs.js2xml(js.elements[0].elements[i].elements[1])
    );

    const mdx = `export const metadata = {\n  name: "${title}",\n  short: "${short}",\n  date: "${date}",\n  online: TODO FIX THIS,\n  location: "${room}",\n  registerLink: TODO FIX THIS,\n}\n\n${abstract}`;
    const mdxTitle = title.replace(/(\s+|:+)/g, "-");

    fs.writeFile(`${mdxTitle}.mdx`, mdx, function (err) {
      if (err) return console.log(err);
    });
  }
};
